# BEGIN COPYRIGHT
# *************************************************************************
#
# Licensed Materials - Property of IBM
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# (C) Copyright IBM Corporation  2007, 2012. All Rights Reserved.
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#
# *************************************************************************
# END COPYRIGHT

from java.lang import System
from java.lang import Boolean;
from java.util.logging import Level;
from com.ibm.wsspi.scripting import ScriptingExtensionHelper

import sys
import re
import sre
import AdminUtilities

#*******************************************************************************************************
# Run a single component's upgrade script
#*******************************************************************************************************
def runComponentUpgrade ( script ):
	global numscripts
	global numerrors
	import os
	rc = 0
	if ( not os.path.isfile( script ) ):
		print "Script '" + script + "' not found, skipping."
	#endIf
	else:
		print "Calling '" + script + "'..."
		numscripts = numscripts+1
		try:
			_excp_ = 0
			# copy the globals so scripts don't overwite any of our stuff
			error = execfile(script, globals().copy())
			_excp_ = 0 #reset (in case of nested exceptions)
		#endTry
		except:
			_type_, _value_, _tbck_ = sys.exc_info()
			error = str(_value_)
			_excp_ = 1
		#endTry
		# ignore error if return code was zero
		# this is what happens if system.exit(0) is called from script
		if (_excp_ == 1):
			if (error == '0'):
				rc = 0
			#endIf
			else:
				rc = _excp_
			#endElse
			#endIf
		else:
			rc = _excp_
			#endElse
		if (rc == 0):
			print "Done calling '" + script + "'."
		#endIf
		else:
			print "Error calling '" + script + "': "+`error`+"."
			print str(_type_)
			print str(_value_)
			print str(_tbck_)
			numerrors = numerrors+1
		#endElse
	#endElse
	return rc
#endDef


#*******************************************************************************************************
# main
#*******************************************************************************************************
errorCode = ""
errorInfo = ""
numscripts = 0
numerrors = 0
runScript = ""
fileName = ""

print "*************************************************************************************"
print "Operating system: " + System.getProperty("os.name")
print "WebSphere installation directory: " + System.getProperty("was.install.root")
print "WebSphere repository location: " + System.getProperty("was.repository.root")
print "Profile directory: " + System.getProperty("user.install.root")
print "Command line options: BPMMigrateAdapter" + `sys.argv`


print ""
print "Executing ValidateDeploymentConfiguration.py"
runComponentUpgrade(System.getProperty("was.install.root") + "/util/upgrade/ValidateDeploymentConfiguration.py")
if (numerrors > 0):
	print "Script ValidateDeploymentConfiguration.py failed, did not complete successfully ", str(numerrors)
	sys.exit(numerrors)
#endIf

print ""
print "Executing ProcessApplicationInformation.py"
runComponentUpgrade(System.getProperty("was.install.root") + "/util/upgrade/ProcessApplicationInformation.py")
if (numerrors > 0):
	print "Script ProcessApplicationInformation.py failed, did not complete successfully ", str(numerrors)
	sys.exit(numerrors)
#endIf

print ""
print "Executing wpsAdapterMigration.py"
runComponentUpgrade(System.getProperty("was.install.root") + "/util/adapterMigration/wpsAdapterMigration.py")
if (numerrors > 0):
	print "Script wpsAdapterMigration.py failed, did not complete successfully ", str(numerrors)
	sys.exit(numerrors)
#endIf
print ""
sys.exit(numerrors)